using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Runtime.CompilerServices;
using Exferia_Maestros.General;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_Aplicacion.Modelos_Generales;

namespace Exferia_Maestros._3_Vistas.Listados
{
    class ABS_Listado_MAE_CuentaBancarias_SEPA_Cobros : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MAE_CuentaBancarias_SEPA_Cobros()
        {
            Rellenar_Columnas();
        }
        public ABS_Listado_MAE_CuentaBancarias_SEPA_Cobros(string _str_Opcion)
        {
            Opcion = _str_Opcion;
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_CuentasBancarias_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, false, false, "", null));

            //referencia
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.referencia), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.referencia), "Código", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, true, true, false, "", null));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.descripcion), "Descripción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true,true, true, false, "", null));

            //iban
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.iban), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.iban), "IBAN", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 250, true, false, false, false, "", null));

            //bicSwift
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.bicSwift), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.bicSwift), "SWIFT", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //recurrente
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.recurrente), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.recurrente), "Recurrente", Enumerados.G_ENUM_TIPOSDATOS.BOOLEAN, false, 90, true, false, false, false, "", null));

            //porDefecto
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.porDefecto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.porDefecto), "Por Defecto", Enumerados.G_ENUM_TIPOSDATOS.BOOLEAN, false, 90, true, false, false, false, "", null));

            //fecha_Cancelado
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.fecha_Cancelado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.fecha_Cancelado), "Fecha Cancelado", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 90, true, false, false, false, "", null));

            //firmante_Nombre
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.firmante_Nombre), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.firmante_Nombre), "Firmante Nombre", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //firmante_nif
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.firmante_nif), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.firmante_nif), "Firmante NIF", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //fecha_FirmaMandato
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.fecha_FirmaMandato), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.fecha_FirmaMandato), "Fecha Firma", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 90, true, false, false, false, "", null));

            //fecha_RecibioMandatoFirmado
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.fecha_RecibioMandatoFirmado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.fecha_RecibioMandatoFirmado), "Fecha recepción Mandato", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 90, true, false, false, false, "", null));

            //Tipo_Texto
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.Tipo_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.Tipo_Texto), "Tipo", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 90, true, false, false, false, "", null));

            //Cliente
            if (Opcion.Equals(Variables.G_STR_OPCION_MAE_CUENTABANCARIA_CLIENTE))
            {
                INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_CLIENTE = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CuentasBancarias_Modelo.idCliente), nameof(MAE_Clientes), nameof(MAE_Clientes.id), nameof(MAE_Clientes.codigo), nameof(MAE_Clientes.razonSocial), nameof(MAE_Clientes.fechaBorrado));
                g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.Cliente), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.Cliente), "Cliente", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_CLIENTE));
            }
            //Socio
            else if (Opcion.Equals(Variables.G_STR_OPCION_MAE_CUENTABANCARIA_SOCIO))
            {
                INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_SOCIO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CuentasBancarias_Modelo.idSocio), nameof(GTT_Socios), nameof(GTT_Socios.id), nameof(GTT_Socios.codigo), nameof(GTT_Socios.razonSocial), nameof(GTT_Socios.fechaBorrado));
                g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.Socio), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.Socio), "Socio", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_SOCIO));
            }

            //Empresa
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CuentasBancarias_Modelo.idEmpresa), nameof(GEN_Empresas), nameof(GEN_Empresas.id), nameof(GEN_Empresas.codigo), nameof(GEN_Empresas.razonSocial), nameof(GEN_Empresas.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.Empresa), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.Empresa), "Empresa", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_EMPRESA));
            
            //EntidadBancaria
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_ENTIDADBANCARIA = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_CuentasBancarias_Modelo.idEntidadBancaria), nameof(GEN_EntidadesBancarias), nameof(GEN_EntidadesBancarias.id), nameof(GEN_EntidadesBancarias.codigo), nameof(GEN_EntidadesBancarias.descripcion), nameof(GEN_EntidadesBancarias.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_CuentasBancarias_Modelo.EntidadBancaria), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_CuentasBancarias_Modelo.EntidadBancaria), "Entidad bancaria", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_ENTIDADBANCARIA));

        }

        private string Opcion { get; set; }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Opcion);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Opcion;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_CuentasBancarias_Modelo.referencia);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
